(ns com.aurellem.item-bridge
  (:use (com.aurellem gb-driver vbm title save-corruption items assembly))
  (:import [com.aurellem.gb_driver SaveState]))


(defn corrupt-item-state []
  (second (destroy-item-end-of-list-marker)))

(defn corrupt-item-state []
  (read-state "corrupt-items"))


(defn view-memory-range [state start end]
  (dorun
   (map (fn [loc val]
          (println (format "%04X : %02X" loc val)))
        
        (range start end) (subvec (vec (memory state)) start end)))
  state)

(defn almost-broken
  "if one more memory location is turned into 0x03, the game crashes."
  [n]
  (view-memory-range
   (set-inv-mem (mid-game)
                (concat [0xFF] (repeat 64 0x03)
                        (subvec (vec (memory (mid-game)))
                                (+ item-list-start 65)
                                (+ item-list-start 65 n))
                        (repeat (- 255 65 n) 0x03)
                        ))
                
   item-list-start (+ item-list-start 255)))

(defn actually-broken
  "if one more memory location is turned into 0x03, the game crashes."
  []
  (set-memory (mid-game) 0xD35D 0x03))


;; (almost-broken 20) more or less works

(defn capture-program-counter
  "records the program counter for each tick"
  [^SaveState state ticks]
  (let [i (atom 0)]
    (reduce (fn [[program-counters state] _]
              (println (swap! i inc))
               [(conj program-counters (PC state))
                (tick state)])
              [[] state]
              (range ticks))))


(defn capture-program-counter
  [^SaveState state ticks]
  (set-state! state)
  (loop [i 0
         pcs []]
    (if (= i ticks)
      pcs
      (do 
        (com.aurellem.gb.Gb/tick)
        (recur (inc i)
               (conj pcs (first (registers))))))))
